module Elastify
    module Helpers
        module ElasticSearch
            class SearchResultCollection
                attr_accessor :scroll_id, :took, :timed_out, :shards_total, :shards_successful, :shards_failed, :hits_total, :hits_maxscore, :hits,
                              :elastify_options

                def initialize(elasticsearch_search_result, elastify_options)
                    @elastify_options = elastify_options
                    @scroll_id = elasticsearch_search_result["_scroll_id"]
                    @took = elasticsearch_search_result["took"]
                    @timed_out = elasticsearch_search_result["timed_out"]
                    @shards_total = elasticsearch_search_result["_shards"]["total"]
                    @shards_successful = elasticsearch_search_result["_shards"]["successful"]
                    @shards_failed = elasticsearch_search_result["_shards"]["failed"]
                    @hits_total = elasticsearch_search_result["hits"]["total"]
                    @hits_maxscore = elasticsearch_search_result["hits"]["maxscore"]
                    @hits = map_hits(elasticsearch_search_result["hits"]["hits"])
                end

                def map_hits(hits)
                    hits.map do |hit|
                        Elastify::Helpers::ElasticSearch::SearchResult.new(hit, @elastify_options)
                    end
                end
            end
        end
    end
end